config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }
  resources :couples, except: [:index, :new]
  resources :verification_codes
  resources :scores, except: [:index]
  resources :match_players, except: [:new, :index, :edit]
  resources :matches, except: [:index, :destroy, :edit]
  resources :events
  
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "events#dashboard"

  # route for a new match-player with a specific event
  get 'match_players/new/:id', to: "match_players#new", as: 'new_match_player'
  get "match_players/edit/:id/(:resend)", to: "match_players#edit", as: "edit_match_player"
  # route to show the players for a specific event
  get 'match_players/index/:id', to: "match_players#index", as: 'players_enrolled'

  
  
  get 'matches/index/:id/(:round)', to: "matches#index", as: 'event_matches'
  get 'matches/player_matches/:event_id/:player_id', to: "matches#player_matches", as: 'player_matches'
  delete "matches/:event_id/:round", to: "matches#destroy", as: "matches_destroy_round"
  get 'matches/create_round_of_matches/:event_id', to: "matches#create_round_of_matches", as: 'create_round_of_matches'
  
  patch "events/update_status/:id", to: "events#update_status", as: "update_status_event"
  get "event/show_closed_event/:id", to: "events#show_closed_event", as: "show_closed_event"
  get "matches/edit/:id/:round", to: "matches#edit", as: "edit_match"
  get "scores/index/:id", to: "scores#index", as: "player_scores"
  
  get "players/new/(:event_id)", to: "players#new", as: "new_player"
  resources :players, except: [:new]
  
  #resources :players do
  #  get "players/new/(:event_id)", to: "players#new", as: "new_player", on: :collection
  #end
  
  get 'couples/index/:id', to: "couples#index", as: 'event_couples'
  get "couples/new/:id", to: "couples#new", as: "new_couple"
  get "players/dashboard/:player_id", to:  "players#dashboard", as: "dashboard_player"
  get "events/dashboard", to: "events#dashboard", as: "dashboard_events"
  #comment x
end 

app/models/event.rb
class Event < ApplicationRecord
    include Rails.application.routes.url_helpers
    STATUS= %w[Open Closed] #Status
    belongs_to :player, optional: true
    attribute :status, :string, default: 'Open'
    has_many :match_player
    has_many :matches
    has_many :score
    has_many :verification_codes
    has_many :results
    has_many :couples
    attribute :message_sent, :boolean, default: false
    def getPlayersPoints
        # Obtain the sumatory of points for all the players for the event {player, total_points} {1=>9, 2=>20, 3=>15, 4=>14, 5=>1, 6=>1}
        id = self.id
        # We grab all the players for the event
        players = MatchPlayer.where(event_id: id, status: "OnBoard")
        points_per_player = {}
        players.each{|player|
            points_per_event = Match.where(event_id: id, playerOne: player.player_id).where.not(pointsOne: nil).collect{|p| p.pointsOne}.sum
            points_per_event += Match.where(event_id: id, playerTwo: player.player_id).where.not(pointsTwo: nil).collect{|p| p.pointsTwo}.sum
            points_per_event += Match.where(event_id: id, playerThree: player.player_id).where.not(pointsThree: nil).collect{|p| p.pointsThree}.sum
            points_per_event += Match.where(event_id: id, playerFour: player.player_id).where.not(pointsFour: nil).collect{|p| p.pointsFour}.sum
            points_per_player[player.player_id] = points_per_event            
        }
        return points_per_player
    end 
    
    def getWinner
        # Get the winner [player, points] for the event
        points_per_player= self.getPlayersPoints.sort_by{|k, v| -v}
        #winner = points_per_player.sort_by{|key, value| value}.last
        
        #here we get noy only one posible winner but n winners
        max=points_per_player.max_by{|key, value| value }
        winner = points_per_player.select{|k, v| v == max[1]}

        points_per_player.each.with_index(1){|point, position|
            if point[1] == max[1]
                #update the position in the score model for the event-player
                score = Score.where(event_id: self.id, player_id: point[0]).first
                score.position = 1                
            else
                score = Score.where(event_id: self.id, player_id: point[0]).first
                score.position = position
            end
            score.save            
        }
        return winner
    end
    
    def updateWinner
        #update the field player_id and winner in the event
        winner = self.getWinner
        self.player_id = winner[0]
        self.winner = winner[1]
        self.save!
    end
    
    def updateScore
        # Update the scores for all the players in the event
        scores = getPlayersPoints # returns {player, total_points}
        scores.each{|player, total_points|
            s=Score.where(event_id: self.id, player_id: player)
            if s.empty?
                Score.create(event_id: self.id, player_id: player, points: total_points)
            else
                s=s[0]
                s.points = total_points
                s.save!
            end
        }

    end
    def onlyLeft
        #return the number of places left for the event {ej: Event people max = 12, players onboard = 4, onlyLeft= 12-4 = 8}
        event = Event.find(self.id)
        #We get the onboard players
        obPlayers = MatchPlayer.where(event_id: event.id, status: "OnBoard").count
        return event.people - obPlayers
    end

    def create_round_of_matches
        if self.mixed
            # Create a set of matches per round depending on the total players for the event (event.people)
            # Example: People = 12. Ergo we need 3 matches (each match 4 different person) per round
            # So this method will generate 3 matches each 4 different person.
            result = false
            event = Event.find(self.id)
            #We create the round robbin
            rounds = round_robin
            #puts "The max num of round is -> #{rounds.size}"
            #Find which round goes?
            num_round=get_num_rounds 
            
            #round_to_create = [[7, 1], [4, 2], [14, 5], [15, 16], [18, 6], [17, 19]]
            #round = [[P1, P2],[P3, P4],      [P1, P2], [P3, P4],       [P1, P2], [P3, P4]]
            if num_round >= rounds.size
                position = num_round%rounds.size
            else
                position = num_round
            end

            round_to_create = rounds[position]
            len = round_to_create.size - 1
            
            #  loop principal que barre todos los elementos de una ronda
            playerOne, playerTwo, playerThree, playerFour = 0
            (0..len).each.with_index{|p, i|    

                if i.even?
                    #puts "Asignation to match.playerOne with -----> #{round_to_create[p][0]}"
                    #puts "Asignation to match.playerTwo with -----> #{round_to_create[p][1]}"
                    playerOne = round_to_create[p][0]
                    playerTwo = round_to_create[p][1]
                    puts "[ #{playerOne}, #{playerTwo} ]"
                    puts ""
                end
                
                if i.odd?
                    #entonces guardamos match
                    #puts "Asignation to match.playerThree with -----> #{round_to_create[p][0]}"
                    #puts "Asignation to match.playerFour with -----> #{round_to_create[p][1]}"
                    playerThree = round_to_create[p][0]
                    playerFour = round_to_create[p][1]
                    puts "[ #{playerThree}, #{playerFour} ]"
                    Match.create(event_id: self.id, playerOne: playerOne, playerTwo: playerTwo, playerThree: playerThree, playerFour: playerFour, round: num_round+1 )
                    
                    #Clear the players
                    playerOne, playerTwo, playerThree, playerFour = 0                
                end
            }
            #puts "Round number #{num_round+1} of matches created ---> #{round_to_create}"
            result = true if get_num_rounds > num_round
        else
            #Fixed couples
            teams = round_robin
            i=0
            
            teams.each.with_index(get_num_rounds+1){|matches, round| 
                #puts "ronda #{round} ----> match #{matches}"
                #ronda n ----> match [[1, 2], [3, 4]]
                #ronda n ----> match [[pareja1 , pareja2], [pareja3, pareja4]]
                matches.each{|match|
                    puts "single match -->#{match}"
                    couple_one = Couple.find(match.first)
                    couple_two = Couple.find(match.second)
                    Match.create(event_id: self.id, round: round, 
                    playerOne: couple_one.player.id, 
                    playerTwo: couple_one.mate.id, 
                    playerThree: couple_two.player.id, 
                    playerFour: couple_two.mate.id )
                }
                i+=1
                
                result = true if i == teams.size                
            }

        end
        return result
    end
    
    
    
    require "round_robin_tournament"
    def round_robin 
        if self.mixed
            match_players = MatchPlayer.where(event_id: self.id, status: "OnBoard")
            players = match_players.collect{|mp| mp.player_id}
            #NOTE: players is a collection of number sorted always in the same way
            # If you want to add another pint of randomness, then you have to pass to the RoundRobinTournament method the player list shuffled
            teams = RoundRobinTournament.schedule(players)
            # Print for each day, each team
            teams.each_with_index do |day, index|
                day_teams = day.map { |team| "(#{team.first}, #{team.last})" }.join(", ")
                #puts "Day #{index + 1}: #{day_teams}"
            end            
        else
            couples = Couple.where(event_id: self.id).collect{|c| c.id}
            couples.shuffle!
            teams = RoundRobinTournament.schedule(couples)
            
        end
        teams.each{|m| m.shuffle!}
        #puts teams
        return teams
    end
    def get_num_rounds
        #returns the number of total rounds created for the event
        num_round=0 
        rounds_created=Match.where(event: self.id).select("round").group("round")
        if rounds_created.any?
            num_round = rounds_created.sort_by{|m| m.round}.last.round     
        end
        return num_round
    end
    def target 
        #returns the datetime target 
        return DateTime.new(self.eventDate.year, self.eventDate.month, self.eventDate.day, self.timeIni.hour, self.timeIni.min, self.timeIni.sec, Rational(-6, 24))
    end    
end

app/controllers/events_controller.rb
class EventsController < ApplicationController
  include Rails.application.routes.url_helpers
  before_action :authenticate_user!, except: %i[ dashboard ]
  before_action :check_user_role, except: %i[ dashboard ]
  before_action :set_event, only: %i[ show edit update destroy update_status show_closed_event]
  

  # GET /events or /events.json
  def index
    @events = Event.all.reverse
  end

  # GET /events/1 or /events/1.json
  def show
  end

  # GET /events/new
  def new
    @event = Event.new
  end

  # GET /events/1/edit
  def edit
  end

  # POST /events or /events.json
  def create
    @event = Event.new(event_params)

    respond_to do |format|
      if @event.save
        format.html { redirect_to event_url(@event), notice: "Event was successfully created." }
        format.json { render :show, status: :created, location: @event }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /events/1 or /events/1.json
  def update
    respond_to do |format|
      if @event.update(event_params)
        format.html { redirect_to event_url(@event), notice: "Event was successfully updated." }
        format.json { render :show, status: :ok, location: @event }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /events/1 or /events/1.json
  def destroy
    @event.destroy

    respond_to do |format|
      format.html { redirect_to events_url, notice: "Event was successfully destroyed." }
      format.json { head :no_content }
    end
  end
  
  # PATCH/PUT /events/1/close or /events/1/close.json
  def update_status 
    respond_to do |format|
      @event.status = "Closed"
      @event.getWinner      
      if @event.save
        #we send the sms to inform to the winners
        send_sms_to_winner if !@event.message_sent

        format.html { redirect_to show_closed_event_path(@event), notice: "Event was succesfully closed!"  }      
        format.json { render :close, status: :ok, location: @event }
      else
        format.html { redirect_to players_enrolled_url(@event), status: :unprocessable_entity }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end

    
  end
  
  def show_closed_event
    @scores = @event.score.where("points > 0").sort_by{|s| s.points}.reverse
  end  

  def send_sms_to_winner
    url = show_closed_event_url(@event.id)        
    @event.score.where(position: 1).each{|winner|
      message = "From Padel Crazy X - Congratulations #{winner.player.name.titleize}, You won the event '#{@event.name}'. See the results here:  #{url}"
      sms = Message.new(number: winner.player.cellphone, body: message, action: "send_sms_to_winner", controller: "events_controller.rb")
      result = sms.send_sms
      sms.error = result.error_message
      sms.save!
      if result.error_message.nil?
        @event.message_sent=true
        @event.save!
      end
    }
  end

  
  def dashboard
    #here we have the next seven days events
    dateIni = Date.today
    #@events = Event.where(public: true, status: "Open", eventDate: dateIni..dateIni+7).collect{|e| e}.group_by{|e| e.eventDate}.sort_by{|ebd| ebd[0]}
    @events = Event.where(public: true, status: "Open", eventDate: dateIni..dateIni+7).select{|e| e if e.target >DateTime.now }.sort_by{|e| e.target }.group_by{|e| e.eventDate}
    #@total_events = Event.where(status: "Open", eventDate: dateIni..dateIni+7).collect{|e| e}.count
    @total_events = Event.where(status: "Open", eventDate: dateIni..dateIni+7).select{|e| e if e.target > DateTime.now}.count
    #@next_event = Event.where(status: "Open", eventDate: dateIni..dateIni+7).collect{|e| e}.sort_by{|e| [e.eventDate, e.timeIni]}.first
    @next_event = Event.where(status: "Open", eventDate: dateIni..dateIni+7).select{|e| e if  e.target > DateTime.now}.sort_by{|e| e.target }.first
    @round = 1
  end
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_event
      @event = Event.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def event_params
      params.require(:event).permit(:name, :eventDate, :people, :status, :winner, :timeIni, :timeEnd, :mixed, :level, :public)
    end
    
    def check_user_role    
      case current_user.role        
        when "Player"
          respond_to do |format|
            format.html { redirect_to dashboard_player_path(current_user.player_id), notice: "...redirected to the dashboard page!"  }
            format.json { head :no_content }
          end
      end
    end
end

app/helpers/events_helper.rb
module EventsHelper
end

app/views/events/_event.html.erb
<div id="<%= dom_id event %>">
  <div class="row">
      <div class="col-md-8">
          <div class="card">
              <div class="card-header pb-0">
                  <div >                                          
                    <%= link_to(events_path, class:"btn bg-gradient-primary ms-auto") do%>
                        <i class="fa fa-list-ol"></i>&nbsp;&nbsp;Event list
                    <%end%>
                  </div>
              </div>
              

                <div class="card-body">                          
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Event name:</label>                              
                                <label for="example-text-input" class="form-control-label"><%= event.name %></label>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Event date:</label>
                                <label for="example-text-input" class="form-control-label"><%= event.eventDate.strftime("%d/%m/%Y") %></label>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Scheduled:</label>
                                <label for="example-text-input" class="form-control-label"><%= event.timeIni.strftime("%H:%M")%> - <%= event.timeEnd.strftime("%H:%M")%></label>
                            </div>
                        </div>                        
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Players (Qty):</label>
                                <label for="example-text-input" class="form-control-label"><%= event.people %></label>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Type:</label>
                                <label for="example-text-input" class="form-control-label"><%= event.mixed? ? "Mixed couples":"Fixed couples" %>, <%= event.public? ? "Public event":"Private event" %></label>                                
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Category:</label>
                                <label for="example-text-input" class="form-control-label"><%= event.level %></label>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Status:</label>
                                <label for="example-text-input" class="form-control-label"><%= event.status %></label>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="example-text-input" class="form-control-label">Winner:</label>
                                <%if !event.player.nil? %>
                                  <%= link_to event.try(:player).try(:name), event.try(:player), class: "text-xs font-weight-bold mb-0" %>                          
                                  <p class="text-xs text-secondary mb-0">Won by &nbsp;<%=event.try(:winner)%> pts</p>
                                <%end%>

                            </div>
                        </div>
                        
                    </div>                                                                    
                </div>
                <div class="card-header pb-3">                        
                    <div class="row">
                        <div class="col-md-3">
                            <%= link_to(edit_event_path(event), class:"btn bg-gradient-secondary ms-auto") do%>
                                Edit&nbsp;&nbsp;<i class="fa fa-edit"></i>
                            <%end%>
                            
                        </div>
                        <div class="col-md-3">
                            
                            <%= button_to(event, method: :delete, form: { data: { turbo_confirm: 'Are you sure?' } }, class: "btn bg-gradient-danger") do %>
                                Delete&nbsp;&nbsp;<i class="fa fa-trash-o"></i>
                            <%end%>
                        </div>
                        
                    </div>                        
                </div>
              

          </div>
      </div>                
  </div>
  <div class="col-md-8">
    <br>
  </div>
  


    <div class="row">        
        <div class="col-md-2">
            <div class="card">
                <div class="card-body">
                    <div class="form-group">
                    <label class="form-control-label" for="basic-url">Add player</label>
                        <%= link_to(new_match_player_path(event), class:"btn bg-gradient-success ms-auto") do%>
                            <i class="fa fa-plus-square"></i>&nbsp;&nbsp;Player
                        <%end%>
                        
                    </div>
                </div>
            </div>
        </div>
        <div class="col-md-6">
            <div class="card">
                <div class="card-body">
                    
                    <div class="form-group">
                        <label class="form-control-label" for="basic-url">Your event URL</label>
                        <div class="input-group">
                        <span class="input-group-text" id="basic-addon3"> <%= new_match_player_url(event, :only_path => false) %></span>                    
                        <button class="btn btn-info mb-0" type="button" id="button-addon2">
                            Share&nbsp;&nbsp;<i class="fa fa-share-alt"></i>
                        </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

  





    
</div>

app/views/events/dashboard.html.erb
<%= render "events_dashboard", next_event: @next_event %>

app/views/events/edit.html.erb
<h3 style= "color: white">Editing event</h3>
<%= render "form", event: @event %>

app/views/events/index.html.erb
<div class="row">
        <div class="col-12">
          <div class="card mb-4">
          <div class="d-flex px-2 py-1">
          </div>
            <div class="card-header pb-0">
              <div class="d-flex align-items-center">
                <p class="h4">Event list</p>
                <%= link_to(new_event_path, class: "btn bg-gradient-primary ms-auto") do %>
                  <i class="fa fa-plus-square"></i> New Event gerardo alfredo
                <% end %>
              </div>
            </div>
            <div class="card-body px-0 pt-0 pb-2">
              <div class="table-responsive p-6">
                <table id= "events_table" class="display compact">
                  <thead>
                    <tr>
                      
                      <th class="text-uppercase text-primary text-s font-weight-bolder">ID</th>
                      <th class="text-uppercase text-primary text-s font-weight-bolder ps-2">Name</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">Date</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">People Qty</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">Status</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">Winner</th>
                      <th class="text-secondary opacity-7"></th>
                      
                    </tr>
                  </thead>
                  <tbody>
                  <% @events.each do | event|%>
                    <tr>
                      <td>
                        <div class="d-flex px-2 py-1">                          
                          <div class="d-flex flex-column justify-content-right">
                            <h6 class="mb-0 text-sm"><%=event.id%></h6>                            
                          </div>
                        </div>
                      </td>
                      <td>                        
                        <%= link_to event.name, event, class: "text-xs font-weight-bold mb-0" %>                                                  
                      </td>
                      <td class="align-middle text-center">
                        <span class="text-secondary text-xs font-weight-bold"><%=event.eventDate.strftime("%d/%m/%Y")%></span>
                      </td>                      
                      <td class="align-middle text-center">
                        <span class="text-secondary text-xs font-weight-bold"> <%=event.people%></span>
                      </td>
                      <td class="align-middle text-center text-sm">
                      <%if event.status=='Open' %>
                        <span class="badge badge-sm bg-gradient-success"><%=event.status%></span>
                      <%else%>
                        <span class="badge badge-sm bg-gradient-secondary"><%=event.status%></span>
                      <%end%>
                      </td>
                      <td>                        
                        
                        
                          <% event.score.where(position: 1).each do |score|%>
                            <div class="d-flex px-2 py-1"> 
                              
                                <div>
                                  <%if !score.player.image_attachment.nil?%>
                                    <%= image_tag(score.player.image, class: "avatar avatar-sm me-3")%>
                                  <%else%>
                                    <%= image_tag("blank-profile-picture.jpg", class: "avatar avatar-sm me-3")%>
                                  <%end%>
                                </div>
                                <div class="d-flex flex-column justify-content-center">
                                  <h6 class="mb-0 text-sm"><%= link_to score.try(:player).try(:name).titleize, show_closed_event_path(event)%></h6>
                                  <p class="text-xs text-secondary mb-0">Won by&nbsp;<%=score.try(:points)%>&nbsp;pts</p>
                                </div>
                              
                            </div>                          
                          <%end%>
                        
                      </td>
                      <td>
                        <div class="dropdown">
                          <button type="button" class="btn btn-sm bg-gradient-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
                            Action
                          </button>
                          <ul class="dropdown-menu px-2 py-3" aria-labelledby="dropdownMenuButton">
                            <li>
                              <%= link_to(edit_event_path(event), class:"dropdown-item border-radius-md") do%>
                                Edit&nbsp;&nbsp;<i class="fa fa-edit"></i>
                              <% end %>
                            </li>
                            
                              
                            <% if event.status.upcase != "CLOSED"%>
                              <li>
                                <%= link_to(event, class:"dropdown-item border-radius-md") do%>
                                  Share&nbsp;&nbsp;<i class="fa fa-share-alt"></i>
                                <%end%>
                              </li>
                            <%end%>
                            <li>
                              <%= link_to(event, data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'}, class:"dropdown-item border-radius-md") do %>
                                Delete&nbsp;&nbsp;<i class="fa fa-trash-o"></i>
                              <%end%>
                            </li>
                            <li>
                              <%= link_to(players_enrolled_path(event), class:"dropdown-item border-radius-md") do%>
                              Players&nbsp;&nbsp;<i class="fa fa-users"></i>
                              <%end%>
                            </li>
                            <li>
                              <%= link_to(event_matches_path(event), class:"dropdown-item border-radius-md") do%>
                              Matches&nbsp;&nbsp;<i class="fa fa-sitemap"></i>
                              <%end%>
                            </li>
                            <% if event.status.upcase == "CLOSED"%>
                              <li>
                                <%= link_to(show_closed_event_path(event), class:"dropdown-item border-radius-md") do%>
                                Results&nbsp;&nbsp;<i class="fa fa-poll"></i>
                                <%end%>
                              </li>
                            <%end%>
                            
                          </ul>
                        </div>
                      </td>                                            
                    </tr>
                    <%end%>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
<script type="text/javascript">
  // In your Javascript (external .js resource or <script> tag)
    $(document).ready(function() {    
    $('#events_table').DataTable();        
  });
</script>

app/views/events/new.html.erb
 <h3 style= "color: white">New event</h3>
<%= render "form", event: @event %>

app/views/events/show.html.erb
 <h3 style= "color: white">Showing event</h3>


<%= render @event %>